/// @file

#ifndef GEM_MANAGERS_EXCEPTION_EXCEPTION_H
#define GEM_MANAGERS_EXCEPTION_EXCEPTION_H

#include <gem/utils/exception/Exception.h>

// The gem::managers exceptions.
#define GEM_MANAGERS_DEFINE_EXCEPTION(EXCEPTION_NAME) GEM_DEFINE_EXCEPTION(EXCEPTION_NAME, managers)
GEM_MANAGERS_DEFINE_EXCEPTION(Exception)
GEM_MANAGERS_DEFINE_EXCEPTION(WriteValueMismatch)
GEM_MANAGERS_DEFINE_EXCEPTION(ConfigurationParseProblem)
GEM_MANAGERS_DEFINE_EXCEPTION(ConfigurationProblem)
GEM_MANAGERS_DEFINE_EXCEPTION(ConfigurationValidationProblem)

GEM_MANAGERS_DEFINE_EXCEPTION(HardwareProblem)
GEM_MANAGERS_DEFINE_EXCEPTION(UninitializedDevice)

GEM_MANAGERS_DEFINE_EXCEPTION(RCMSNotificationError)
GEM_MANAGERS_DEFINE_EXCEPTION(SOAPTransitionProblem)
GEM_MANAGERS_DEFINE_EXCEPTION(NULLReadoutPointer)

GEM_MANAGERS_DEFINE_EXCEPTION(SoftwareProblem)
GEM_MANAGERS_DEFINE_EXCEPTION(TransitionProblem)
GEM_MANAGERS_DEFINE_EXCEPTION(ValueError)

GEM_MANAGERS_DEFINE_EXCEPTION(RPCMethodError)

GEM_MANAGERS_DEFINE_EXCEPTION(DeviceNameParseError)

// The gem::manager alarms.
#define GEM_MANAGERS_DEFINE_ALARM(ALARM_NAME) GEM_MANAGERS_DEFINE_EXCEPTION(ALARM_NAME)

GEM_MANAGERS_DEFINE_ALARM(MonitoringFailureAlarm)

#endif // GEMMANAGERS_EXCEPTION_EXCEPTION_H
